unit uAbstractExpression;

interface

uses
  Classes, uContext;

type
  { AbstractExpression }
  TAbstractExpression = class
  protected
    // Varivel que armanezar as partes da entrada
    Partes: TStringList;
  public
    constructor Create;
    destructor Destroy; override;

    // Mtodo que ser sobrescrito por todas as classes herdadas
    procedure Interpretar(Contexto: TContext); virtual; abstract;
  end;

implementation

uses
  SysUtils;

{ TAbstractExpression }

constructor TAbstractExpression.Create;
begin
  Partes := TStringList.Create;
end;

destructor TAbstractExpression.Destroy;
begin
  FreeAndNil(Partes);
end;

end.
